* Code for Bellemare, Marc F., 		*
* "Agricultural Extension and Imperfect *
* Supervision in Contract Farming: 	*
* Evidence from Madagascar"		*
* Agricultural Economics, forthcoming.	*

* Code Author: Marc F. Bellemare	*
* Assistant Professor of Public Policy	*
* and Economics, Duke University	*

* This Version: February 2, 2010	*

clear
drop _all
set mem 512m
set matsize 300




use "C:\LecofruitData"


log using "C:\Lecofruit", replace

reg ln_yield ln_monitor ln_labor ln_area length age age_2 gender educ hhsize depr dist_house color_2 color_3 texture_2 texture_3 greenbeans leeks cucumber fiv_2 fiv_3 fiv_4 if (g31c21<=115 & g31c21>=111) & g31c22==1, 

predict yhat
rename yhat sample2

gen eta_cs1 = _b[ln_monitor]

reg ln_yield ln_monitor ln_mon_edu ln_labor ln_area length age age_2 gender educ hhsize depr dist_house color_2 color_3 texture_2 texture_3 greenbeans leeks cucumber fiv_2 fiv_3 fiv_4 if (g31c21<=115 & g31c21>=111) & g31c22==1, 


predictnl eta_cs2 = _b[ln_monitor] + _b[ln_mon_edu]*educ

gen a = (g31c81 + g31c82 + g31c83)

gen b = (g31c71 + g31c72 + g31c73)

gen c = (g31c62 + g31c63 + g31c64 + g31c65)


gen fert_pct = g31c81/(g31c81 + g31c82 + g31c83)

replace fert_pct = 0 if a == 0

gen pest_pct = g31c71/(g31c71 + g31c72 + g31c73)

replace pest_pct = 0 if b == 0

gen seeds_pct = g31c62/(g31c62 + g31c63 + g31c64 + g31c65)

replace seeds_pct = 0 if c == 0

drop a b c

gen tot_pct = (g31c81 + g31c71 + g31c62)/(g31c81 + g31c82 + g31c83 + g31c71 + g31c72 + g31c73 + g31c62 + g31c63 + g31c64 + g31c65)

replace tot_pct = 0 if (g31c81 + g31c82 + g31c83 + g31c71 + g31c72 + g31c73 + g31c62 + g31c63 + g31c64 + g31c65)==0

gen gb_last = 1 if d15dc1a==1 | d15dc1b==1  | d15dc1c==1  | d15dc1d==1
replace gb_last = 0 if gb_last==.
gen cu_last = 1 if d15dc1a==2 | d15dc1b==2  | d15dc1c==2  | d15dc1d==2
replace cu_last = 0 if cu_last==.
gen le_last = 1 if d15dc1a==3 | d15dc1b==3  | d15dc1c==3  | d15dc1d==3
replace le_last = 0 if le_last==.
gen sp_last = 1 if d15dc1a==4 | d15dc1b==4  | d15dc1c==4  | d15dc1d==4
replace sp_last = 0 if sp_last==.

gen gb_first = 1 if d15dc2a==1 | d15dc2b==1  | d15dc2c==1  | d15dc2d==1
replace gb_first = 0 if gb_first==.
gen cu_first = 1 if d15dc2a==2 | d15dc2b==2  | d15dc2c==2  | d15dc2d==2
replace cu_first = 0 if cu_first==.
gen le_first = 1 if d15dc2a==3 | d15dc2b==3  | d15dc2c==3  | d15dc2d==3
replace le_first = 0 if le_first==.
gen sp_first = 1 if d15dc2a==4 | d15dc2b==4  | d15dc2c==4  | d15dc2d==4
replace sp_first = 0 if sp_first==.

gen exp_gb = 1 if gb_last==1
gen exp_cu = 1 if cu_last==1
gen exp_sp = 1 if sp_last==1
gen exp_le = 1 if le_last==1

gen crop_exp = 1 if greenbeans==1 & exp_gb==1
replace crop_exp = 1 if cucumbers==1 & exp_cu==1
replace crop_exp = 1 if snowpeas==1 & exp_sp==1
replace crop_exp = 1 if leeks==1 & exp_le==1
replace crop_exp = 0 if crop_exp==.


drop e2

xtreg ln_yield ln_monitor ln_mon_edu ln_labor ln_area greenbeans leeks if (g31c21<=115 & g31c21>=111) & g31c22==1, fe i(a6codc)
egen ybar = mean(ln_yield)
gen y2 = (ln_yield - ybar)^2
predict resid, e
gen e2 = resid^2
drop resid
egen sse = sum(e2)
egen sst = sum(y2)
gen r2 = 1 - sse/sst
sum r2
drop sse sst y2 e2 ybar r2



predict yhat
rename yhat sample

reg ln_monitor ln_labor ln_area length age age_2 gender educ hhsize depr dist_house color_2 color_3 texture_2 texture_3 greenbeans leeks cucumber fiv_2 fiv_3 fiv_4 pest_pct fert_pct seeds_pct if (g31c21<=115 & g31c21>=111) & g31c22==1 & sample2~=.

ivreg2 ln_yield ln_labor ln_area length age age_2 gender educ hhsize depr dist_house color_2 color_3 texture_2 texture_3 greenbeans leeks cucumber fiv_2 fiv_3 fiv_4 (ln_monitor = pest_pct fert_pct seeds_pct) if (g31c21<=115 & g31c21>=111) & g31c22==1, first ffirst


gen eta_iv1 = _b[ln_monitor]

xtreg ln_yield ln_monitor ln_labor ln_area greenbeans leeks if (g31c21<=115 & g31c21>=111) & g31c22==1 & sample~=., fe i(a6codc) 
egen ybar = mean(ln_yield)
gen y2 = (ln_yield - ybar)^2
predict resid, e
gen e2 = resid^2
drop resid
egen sse = sum(e2)
egen sst = sum(y2)
gen r2 = 1 - sse/sst
sum r2
drop sse sst y2 e2 ybar r2

predictnl eta_xt1 = _b[ln_monitor]


xtreg ln_yield ln_monitor ln_mon_edu ln_labor ln_area greenbeans leeks if (g31c21<=115 & g31c21>=111) & g31c22==1  & sample~=., fe i(a6codc)
egen ybar = mean(ln_yield)
gen y2 = (ln_yield - ybar)^2
predict resid, e
gen e2 = resid^2
drop resid
egen sse = sum(e2)
egen sst = sum(y2)
gen r2 = 1 - sse/sst
sum r2
drop sse sst y2 e2 ybar r2

predictnl eta_xt2 = _b[ln_monitor] + _b[ln_mon_edu]*educ

xtreg ln_yield ln_monitor ln_labor ln_area greenbeans leeks if (g31c21<=115 & g31c21>=111) & g31c22==1 & sample2~=., fe i(a6codc) 
egen ybar = mean(ln_yield)
gen y2 = (ln_yield - ybar)^2
predict resid, e
gen e2 = resid^2
drop resid
egen sse = sum(e2)
egen sst = sum(y2)
gen r2 = 1 - sse/sst
sum r2
drop sse sst y2 e2 ybar r2

predictnl eta_xt1a = _b[ln_monitor]


xtreg ln_yield ln_monitor ln_mon_edu ln_labor ln_area greenbeans leeks if (g31c21<=115 & g31c21>=111) & g31c22==1  & sample2~=., fe i(a6codc)
egen ybar = mean(ln_yield)
gen y2 = (ln_yield - ybar)^2
predict resid, e
gen e2 = resid^2
drop resid
egen sse = sum(e2)
egen sst = sum(y2)
gen r2 = 1 - sse/sst
sum r2
drop sse sst y2 e2 ybar r2

predictnl eta_xt2a = _b[ln_monitor] + _b[ln_mon_edu]*educ

xi: ivreg2 ln_yield ln_labor ln_area greenbeans leeks i.a6codc (ln_monitor = pest_pct fert_pct seeds_pct) if (g31c21<=115 & g31c21>=111) & g31c22==1  & sample~=., first ffirst


xtreg ln_monitor pest_pct fert_pct seeds_pct ln_labor ln_area greenbeans leeks if (g31c21<=115 & g31c21>=111) & g31c22==1  & sample2~=., fe i(a6codc)
egen ybar = mean(ln_yield)
gen y2 = (ln_yield - ybar)^2
predict resid, e
gen e2 = resid^2
drop resid
egen sse = sum(e2)
egen sst = sum(y2)
gen r2 = 1 - sse/sst
sum r2
drop sse sst y2 e2 ybar r2




xtivreg ln_yield ln_labor ln_area greenbeans leeks (ln_monitor = pest_pct fert_pct seeds_pct) if (g31c21<=115 & g31c21>=111) & g31c22==1  & sample~=., fe i(a6codc) first
egen ybar = mean(ln_yield)
gen y2 = (ln_yield - ybar)^2
predict resid, e
gen e2 = resid^2
drop resid
egen sse = sum(e2)
egen sst = sum(y2)
gen r2 = 1 - sse/sst
sum r2
drop sse sst y2 e2 ybar r2

predictnl eta_xtiv1 = _b[ln_monitor]

est store inst

xtreg ln_yield ln_monitor ln_labor ln_area greenbeans leeks if (g31c21<=115 & g31c21>=111) & g31c22==1  & sample~=., fe i(a6codc)
egen ybar = mean(ln_yield)
gen y2 = (ln_yield - ybar)^2
predict resid, e
gen e2 = resid^2
drop resid
egen sse = sum(e2)
egen sst = sum(y2)
gen r2 = 1 - sse/sst
sum r2
drop sse sst y2 e2 ybar r2

est store uninst

hausman inst uninst



xtivreg ln_yield ln_labor ln_area greenbeans leeks (ln_monitor = pest_pct fert_pct seeds_pct) if (g31c21<=115 & g31c21>=111) & g31c22==1  & sample2~=., fe i(a6codc) first
egen ybar = mean(ln_yield)
gen y2 = (ln_yield - ybar)^2
predict resid, e
gen e2 = resid^2
drop resid
egen sse = sum(e2)
egen sst = sum(y2)
gen r2 = 1 - sse/sst
sum r2
drop sse sst y2 e2 ybar r2

est store inst2

xtreg ln_yield ln_monitor ln_labor ln_area greenbeans leeks if (g31c21<=115 & g31c21>=111) & g31c22==1  & sample2~=., fe i(a6codc)
egen ybar = mean(ln_yield)
gen y2 = (ln_yield - ybar)^2
predict resid, e
gen e2 = resid^2
drop resid
egen sse = sum(e2)
egen sst = sum(y2)
gen r2 = 1 - sse/sst
sum r2
drop sse sst y2 e2 ybar r2

est store uninst2

hausman inst2 uninst2

sum yield labor cult_area monitoring greenbeans leeks cucumbers seeds_pct pest_pct fert_pct color_1 color_2 color_3 texture_1 texture_2 texture_3 hhsize depr age gender educ length fiv_1 fiv_2 fiv_3 fiv_4 if (g31c21<=115 & g31c21>=111) & g31c22==1  & sample~=.

keep if (g31c21<=115 & g31c21>=111) & g31c22==1  & sample~=.


mean eta*, level(99)
mean eta*, level(95)
mean eta*, level(90)



* Referee #2's Suggestion to Retain 	*
* Observations with Missing Values	*

gen seeds_pct_miss = 1 if seeds_pct == .
replace seeds_pct_miss = 0 if seeds_pct ~= .
replace seeds_pct = 0 if seeds_pct==.

gen hhsize_miss = 1 if hhsize == .
replace hhsize_miss = 0 if hhsize ~= .
replace hhsize = 0 if hhsize==.

gen depr_miss = 1 if depr == .
replace depr_miss = 0 if depr ~= .
replace depr = 0 if depr==.

gen length_miss = 1 if length == .
replace length_miss = 0 if length ~= .
replace length = 0 if length==.

gen dist_miss = 1 if dist_house == .
replace dist_miss = 0 if dist_house~= .
replace dist_house= 0 if dist_house==.


reg ln_yield ln_monitor ln_labor ln_area length age age_2 gender educ hhsize depr dist_house color_2 color_3 texture_2 texture_3 greenbeans leeks cucumber fiv_2 fiv_3 fiv_4 hhsize_miss depr_miss length_miss if (g31c21<=115 & g31c21>=111) & g31c22==1, 

gen eta_cs1miss = _b[ln_monitor]


reg ln_yield ln_monitor ln_mon_edu ln_labor ln_area length age age_2 gender educ hhsize depr dist_house color_2 color_3 texture_2 texture_3 greenbeans leeks cucumber fiv_2 fiv_3 fiv_4 hhsize_miss depr_miss length_miss if (g31c21<=115 & g31c21>=111) & g31c22==1, 

predictnl eta_cs2miss = _b[ln_monitor] + _b[ln_mon_edu]*educ




* Referee #1's Question Regarding 	*
* Overlapping Plantings			*


replace g31m2 = 13 if g31m2 < g31m1

gen duration = g31m2 - g31m1

xtsum duration

sort a6codc

gen a = 1


by a6codc: egen b = sd(duration)
replace b = 0 if b == .

by a6codc: egen a_sum = sum(a)

gen dur_var = b


sum dur_var a_sum

count if dur_var > 0 & a_sum > 1

drop if a_sum == 1


duplicates drop a6codc, force

tab a_sum dur_var


log close




